struct City {
	name:    String,
	no:      String,
	age:     u32,
}

fn main() {
    let mut city = City {
        no: String::from("021"),
        name: String::from("shanghai"),
        age: 10,
    };

    println!("name: {}, no: {}, age: {}", city.name, city.no, city.age);

    city.age += 1;
    println!("name: {}, no: {}, age: {}", city.name, city.no, city.age);

    let city = new_city(String::from("shanghai"), String::from("021"), 10);
    println!("name: {}, no: {}, age: {}", city.name, city.no, city.age);

    // struct 更新
    let city2 = City {
        name: String::from("moudu"),
        ..city
    };
    println!("name: {}, no: {}, age: {}", city2.name, city2.no, city2.age);
}

// 初始化简写示例
fn new_city(name: String, no: String, age: u32) -> City {
    City {
        no,  // 简写：初始化字段 no 为变量 no 的值，下同
        name,
        age: age, // 非简写
    }
}
